/*
 * SDDModuleControlPanel.java
 *
 * Created on June 9, 2006, 1:51 AM
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package sddm;

/**
 *
 * @author Erik J. Tollerud
 * This class is the superclass of all control panels for Stereo Data Display Modules
 */
public abstract class SDDModuleControlPanel extends javax.swing.JPanel{
    protected StereoCamera cam;
    
    /** Creates a new instance of SDDModuleControlPanel */
    public SDDModuleControlPanel() {
        super();
        cam = new StereoCamera();
    }
    /**
     * Creates a new instance of SDDModuleControlPanel
     * @param camera the module should use
     */
    public SDDModuleControlPanel(StereoCamera camera) {
        super();
        cam = camera;
    }
    /**
     * Returns the camera used by this control panel
     * @return  the camera used in this panel
     */
    public StereoCamera getCamera() {
        return cam;
    }
    /**
     * Sets the camera for this control panel
     * @param camera the camera to use in this panel
     */
    public void setCamera(StereoCamera camera) {
        cam = camera;
    }
    /**
     * Uses a module to set the panel's status
     * @param module the module to set the panel to
     */
    public abstract void moduleSettingsToPanel(SDDModule module);
    /**
     * Uses the panel to generate a module with settings based on the panel
     * @param module module to apply settings to. if null, creates module without associated data
     * @return the supplied module or a new one if the parameter is null
     */
    public abstract SDDModule panelToModuleSettings(SDDModule module);
    /**
     * repaints the GLJFrames attached to the oarent StereoCameraControlFrame
     */
    public void redisplayParent() {
        ((StereoCameraControlFrame)this.getRootPane().getParent()).redisplay();
    }
    
    /**
     * Retrieves the control frame this panel is present in
     * @return the control frame
     */
    public StereoCameraControlFrame getControlFrame() {
        return (StereoCameraControlFrame)this.getRootPane().getParent();
    }

}
