/*
 * StereoImageModuleControlPanel.java
 *
 * Created on July 15, 2006, 11:07 AM
 */

package sddm.modules;

import sddm.*;
import sddm.SDDModule;
import sddm.SDDModuleControlPanel;

/**
 *
 * @author  Erik J. Tollerud
 */
public class StereoImageModuleControlPanel extends SDDModuleControlPanel {
    
    StereoImageModule mod;
    
    /** Creates new form StereoImageModuleControlPanel */
    public StereoImageModuleControlPanel(StereoImageModule module) {
        super();
        this.mod = module;
        initComponents();
    }
    public StereoImageModuleControlPanel(StereoImageModule module, StereoCamera cam) {
        super(cam);
        this.mod = module;
        initComponents();
    }
    
    public SDDModule panelToModuleSettings(SDDModule module) {
        StereoImageModule retMod;
        if (module == null)
            retMod = new StereoImageModule(cam);
        else
            retMod = (StereoImageModule)module;
        
        retMod.setAdvanceOnDisplay(this.advanceBox.isSelected());
        
        retMod.setReshapeToActualImageRatio(this.reshapeCheckBox.isSelected());
        
        return retMod;
    }
    
    public void moduleSettingsToPanel(SDDModule module) {
        StereoImageModule sim = (StereoImageModule)module;
        this.advanceBox.setSelected(sim.isAdvanceOnDisplay());
        this.updateImageIndexFromModule(sim);
        this.reshapeCheckBox.setSelected(sim.isReshapeToActualImageRatio());
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        imageToAdjustGroup = new javax.swing.ButtonGroup();
        axisGroup = new javax.swing.ButtonGroup();
        mouseInteractionGroup = new javax.swing.ButtonGroup();
        advanceBox = new javax.swing.JCheckBox();
        advanceButton = new javax.swing.JButton();
        currIndexField = new javax.swing.JTextField();
        jLabel1 = new javax.swing.JLabel();
        leftImageButton = new javax.swing.JRadioButton();
        rightImageButton = new javax.swing.JRadioButton();
        rotButton = new javax.swing.JButton();
        rotSizeField = new javax.swing.JFormattedTextField(java.text.NumberFormat.getInstance());
        transXButton = new javax.swing.JButton();
        transSizeField = new javax.swing.JFormattedTextField(java.text.NumberFormat.getInstance());
        scaleButton = new javax.swing.JButton();
        resetButton = new javax.swing.JButton();
        reshapeCheckBox = new javax.swing.JCheckBox();
        scaleSizeField = new javax.swing.JFormattedTextField(java.text.NumberFormat.getInstance());
        xAxisButton = new javax.swing.JRadioButton();
        yAxisButton = new javax.swing.JRadioButton();
        transRadioButton = new javax.swing.JRadioButton();
        rotRadioButton = new javax.swing.JRadioButton();
        scaleRadioButton = new javax.swing.JRadioButton();
        jLabel2 = new javax.swing.JLabel();

        setPreferredSize(new java.awt.Dimension(388, 174));
        advanceBox.setSelected(mod.isAdvanceOnDisplay());
        advanceBox.setText("advance on each display");
        advanceBox.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        advanceBox.setMargin(new java.awt.Insets(0, 0, 0, 0));
        advanceBox.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                advanceBoxActionPerformed(evt);
            }
        });

        advanceButton.setText("Advance");
        advanceButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                advanceButtonActionPerformed(evt);
            }
        });

        currIndexField.setEditable(false);
        currIndexField.setText(this.mod.isAdvanceOnDisplay() ? "N/A" : Integer.toString(this.mod.getImageIndex()));

        jLabel1.setText("Current Image (o-index)");

        imageToAdjustGroup.add(leftImageButton);
        leftImageButton.setSelected(true);
        leftImageButton.setText("left Image");
        leftImageButton.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        leftImageButton.setMargin(new java.awt.Insets(0, 0, 0, 0));

        imageToAdjustGroup.add(rightImageButton);
        rightImageButton.setText("right Image");
        rightImageButton.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        rightImageButton.setMargin(new java.awt.Insets(0, 0, 0, 0));

        rotButton.setText("Rotate");
        rotButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                rotButtonActionPerformed(evt);
            }
        });

        rotSizeField.setText("num");
        rotSizeField.setValue(mod.getMouseRotStep());
        rotSizeField.setSize(rotSizeField.getPreferredSize().width+15,rotSizeField.getPreferredSize().height);
        rotSizeField.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                rotSizeFieldActionPerformed(evt);
            }
        });

        transXButton.setText("Translate");
        transXButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                transXButtonActionPerformed(evt);
            }
        });

        transSizeField.setText("num");
        transSizeField.setValue(mod.getMouseTransStep());
        transSizeField.setSize(transSizeField.getPreferredSize().width+30,transSizeField.getPreferredSize().height);
        transSizeField.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                transSizeFieldActionPerformed(evt);
            }
        });

        scaleButton.setText("Scale");
        scaleButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                scaleButtonActionPerformed(evt);
            }
        });

        resetButton.setText("Reset Adjustments");
        resetButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                resetButtonActionPerformed(evt);
            }
        });

        reshapeCheckBox.setSelected(mod.isReshapeToActualImageRatio());
        reshapeCheckBox.setText("reshape to Image Size");
        reshapeCheckBox.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        reshapeCheckBox.setMargin(new java.awt.Insets(0, 0, 0, 0));
        reshapeCheckBox.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                reshapeCheckBoxActionPerformed(evt);
            }
        });

        scaleSizeField.setText("num");
        scaleSizeField.setValue(mod.getMouseScaleStep());
        transSizeField.setSize(transSizeField.getPreferredSize().width+30,transSizeField.getPreferredSize().height);
        scaleSizeField.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                scaleSizeFieldActionPerformed(evt);
            }
        });

        axisGroup.add(xAxisButton);
        xAxisButton.setSelected(true);
        xAxisButton.setText("X");
        xAxisButton.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        xAxisButton.setMargin(new java.awt.Insets(0, 0, 0, 0));

        axisGroup.add(yAxisButton);
        yAxisButton.setText("Y");
        yAxisButton.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        yAxisButton.setMargin(new java.awt.Insets(0, 0, 0, 0));

        mouseInteractionGroup.add(transRadioButton);
        transRadioButton.setText("Translate");
        transRadioButton.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        transRadioButton.setMargin(new java.awt.Insets(0, 0, 0, 0));
        transRadioButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                transRadioButtonActionPerformed(evt);
            }
        });

        mouseInteractionGroup.add(rotRadioButton);
        rotRadioButton.setSelected(true);
        rotRadioButton.setText("Rotate");
        rotRadioButton.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        rotRadioButton.setMargin(new java.awt.Insets(0, 0, 0, 0));
        rotRadioButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                rotRadioButtonActionPerformed(evt);
            }
        });

        mouseInteractionGroup.add(scaleRadioButton);
        scaleRadioButton.setText("Scale");
        scaleRadioButton.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        scaleRadioButton.setMargin(new java.awt.Insets(0, 0, 0, 0));
        scaleRadioButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                scaleRadioButtonActionPerformed(evt);
            }
        });

        jLabel2.setText("Mouse Interaction");

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(layout.createSequentialGroup()
                        .addContainerGap()
                        .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING)
                            .add(advanceBox)
                            .add(layout.createSequentialGroup()
                                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                                    .add(currIndexField, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                                    .add(jLabel1))
                                .add(8, 8, 8))))
                    .add(layout.createSequentialGroup()
                        .add(35, 35, 35)
                        .add(advanceButton))
                    .add(layout.createSequentialGroup()
                        .addContainerGap()
                        .add(reshapeCheckBox)))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING, false)
                    .add(layout.createSequentialGroup()
                        .add(leftImageButton)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(rightImageButton))
                    .add(layout.createSequentialGroup()
                        .add(17, 17, 17)
                        .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING, false)
                            .add(layout.createSequentialGroup()
                                .add(rotButton)
                                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED, 22, Short.MAX_VALUE)
                                .add(rotSizeField, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                            .add(layout.createSequentialGroup()
                                .add(scaleButton)
                                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                .add(scaleSizeField, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                            .add(layout.createSequentialGroup()
                                .add(transXButton)
                                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                                .add(transSizeField, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                            .add(layout.createSequentialGroup()
                                .add(xAxisButton)
                                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                                .add(yAxisButton))
                            .add(resetButton))
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING, false)
                            .add(layout.createSequentialGroup()
                                .add(4, 4, 4)
                                .add(jLabel2))
                            .add(scaleRadioButton)
                            .add(rotRadioButton)
                            .add(transRadioButton)))))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .addContainerGap()
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(advanceBox)
                    .add(leftImageButton)
                    .add(rightImageButton))
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(layout.createSequentialGroup()
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                            .add(advanceButton)
                            .add(rotButton)
                            .add(rotSizeField, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                            .add(jLabel1)
                            .add(transXButton, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 23, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                            .add(transSizeField, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                            .add(currIndexField, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                            .add(scaleButton)
                            .add(scaleSizeField, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                            .add(reshapeCheckBox)
                            .add(xAxisButton)
                            .add(yAxisButton))
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(resetButton))
                    .add(layout.createSequentialGroup()
                        .add(11, 11, 11)
                        .add(jLabel2)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(rotRadioButton)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(transRadioButton)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(scaleRadioButton)))
                .addContainerGap(org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
    }// </editor-fold>//GEN-END:initComponents

    private void scaleSizeFieldActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_scaleSizeFieldActionPerformed
        mod.setMouseScaleStep(((Number)scaleSizeField.getValue()).floatValue());
    }//GEN-LAST:event_scaleSizeFieldActionPerformed

    private void transSizeFieldActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_transSizeFieldActionPerformed
        mod.setMouseTransStep(((Number)transSizeField.getValue()).floatValue());
    }//GEN-LAST:event_transSizeFieldActionPerformed

    private void rotSizeFieldActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_rotSizeFieldActionPerformed
        mod.setMouseRotStep(((Number)rotSizeField.getValue()).floatValue());
    }//GEN-LAST:event_rotSizeFieldActionPerformed

    private void scaleRadioButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_scaleRadioButtonActionPerformed
        if (scaleRadioButton.isSelected())
            mod.setMouseInteraction(StereoImageModule.MouseInteraction.SCALE);
    }//GEN-LAST:event_scaleRadioButtonActionPerformed

    private void transRadioButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_transRadioButtonActionPerformed
        if (transRadioButton.isSelected())
            mod.setMouseInteraction(StereoImageModule.MouseInteraction.TRANS);
    }//GEN-LAST:event_transRadioButtonActionPerformed

    private void rotRadioButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_rotRadioButtonActionPerformed
        if (rotRadioButton.isSelected())
            mod.setMouseInteraction(StereoImageModule.MouseInteraction.ROT);
    }//GEN-LAST:event_rotRadioButtonActionPerformed

    private void scaleButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_scaleButtonActionPerformed
        if (this.xAxisButton.isSelected())
            mod.scaleX(((Number)this.scaleSizeField.getValue()).floatValue(),this.rightImageButton.isSelected());
        else
            mod.scaleY(((Number)this.scaleSizeField.getValue()).floatValue(),this.rightImageButton.isSelected());
        this.redisplayParent();
    }//GEN-LAST:event_scaleButtonActionPerformed

    private void transXButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_transXButtonActionPerformed
        if (this.xAxisButton.isSelected())
            mod.translateX(((Number)this.transSizeField.getValue()).floatValue(),this.rightImageButton.isSelected());
        else
            mod.translateY(((Number)this.transSizeField.getValue()).floatValue(),this.rightImageButton.isSelected());
         this.redisplayParent();
    }//GEN-LAST:event_transXButtonActionPerformed

    private void reshapeCheckBoxActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_reshapeCheckBoxActionPerformed
        mod.setReshapeToActualImageRatio(reshapeCheckBox.isSelected());
        this.redisplayParent();
    }//GEN-LAST:event_reshapeCheckBoxActionPerformed

    private void resetButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_resetButtonActionPerformed
        mod.rotate(-mod.getRotation(false),false);
        mod.rotate(-mod.getRotation(true),true);
        mod.translateX(-mod.getXTranslation(false),false);
        mod.translateX(-mod.getXTranslation(true),true);
        mod.translateY(-mod.getYTranslation(false),false);
        mod.translateY(-mod.getYTranslation(true),true);
        mod.scaleX(-mod.getXScale(false),false);
        mod.scaleX(1,false);
        mod.scaleX(-mod.getXScale(true),true);
        mod.scaleX(1,true);
        mod.scaleY(-mod.getYScale(false),false);
        mod.scaleY(1,false);
        mod.scaleY(-mod.getYScale(true),true);
        mod.scaleY(1,true);
        this.redisplayParent();
    }//GEN-LAST:event_resetButtonActionPerformed
    
    private void rotButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_rotButtonActionPerformed
        mod.rotate(((Number)this.rotSizeField.getValue()).floatValue(),this.rightImageButton.isSelected());
         this.redisplayParent();
    }//GEN-LAST:event_rotButtonActionPerformed
    
    private void advanceButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_advanceButtonActionPerformed
        mod.advance();
        this.moduleSettingsToPanel(mod);
        this.redisplayParent();
    }//GEN-LAST:event_advanceButtonActionPerformed
    
    private void advanceBoxActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_advanceBoxActionPerformed
        mod.setAdvanceOnDisplay(advanceBox.isSelected());
        this.updateImageIndexFromModule(this.mod);
    }//GEN-LAST:event_advanceBoxActionPerformed
    
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JCheckBox advanceBox;
    private javax.swing.JButton advanceButton;
    private javax.swing.ButtonGroup axisGroup;
    private javax.swing.JTextField currIndexField;
    private javax.swing.ButtonGroup imageToAdjustGroup;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JRadioButton leftImageButton;
    private javax.swing.ButtonGroup mouseInteractionGroup;
    private javax.swing.JButton resetButton;
    private javax.swing.JCheckBox reshapeCheckBox;
    private javax.swing.JRadioButton rightImageButton;
    private javax.swing.JButton rotButton;
    private javax.swing.JRadioButton rotRadioButton;
    private javax.swing.JFormattedTextField rotSizeField;
    private javax.swing.JButton scaleButton;
    private javax.swing.JRadioButton scaleRadioButton;
    private javax.swing.JFormattedTextField scaleSizeField;
    private javax.swing.JRadioButton transRadioButton;
    private javax.swing.JFormattedTextField transSizeField;
    private javax.swing.JButton transXButton;
    private javax.swing.JRadioButton xAxisButton;
    private javax.swing.JRadioButton yAxisButton;
    // End of variables declaration//GEN-END:variables
    
    public void updateImageIndexFromModule(StereoImageModule sim) {
        this.currIndexField.setSize(this.currIndexField.getPreferredSize());
        String s = this.mod.isAdvanceOnDisplay() ? "N/A" : Integer.toString(this.mod.getImageIndex());
        this.currIndexField.setText(s);
        
    }
    
}
